/*̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief FAT12/16/32޽
 *
 * ̧قAVR32޲łFATp֐̗Lpȑg`܂B
 *
 * \author	Atmel Corporation	: http://www.atmel.com \n
 *			xFAQ			: http://support.atmel.no/
 *
 *****************************************************************************/

/* 쌠 (c) 2006-2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#define _fat_c_

//_____ ݸٰ ____________________________________________________________
#include "conf_explorer.h"
#include "fs_com.h"
#include "fat.h"
#include LIB_MEM
#include LIB_CTRLACCESS

//_____ ` _______________________________________________________________

//! \name IȂUް̊i[
//! @{
#if (FS_NB_NAVIGATOR > 1)
_MEM_TYPE_SLOW_ Fs_management		fs_g_navext[FS_NB_NAVIGATOR-1];
_MEM_TYPE_SLOW_ Fs_management_fast	fs_g_navext_fast[FS_NB_NAVIGATOR-1];
_MEM_TYPE_SLOW_ Fs_management_entry	fs_g_navext_entry[FS_NB_NAVIGATOR-1];
#endif
//! @}

//! \name ׽ꗗǗ邽߂̕ϐ
//! @{
_MEM_TYPE_SLOW_ Fs_clusterlist_cache fs_g_cache_clusterlist[FS_NB_CACHE_CLUSLIST*2];
_MEM_TYPE_SLOW_ U8 fs_g_u8_current_cache;
//! @}

//_____ 錾 _______________________________________________________________

void fat_cache_clusterlist_update_start  (Bool b_for_file);
void fat_cache_clusterlist_update_finish (void);
Bool fat_cache_clusterlist_update_read   (Bool b_for_file);
void fat_cache_clusterlist_update_select (void);

//! ̊֐͑uԂ𒲂ׂ܂B
//!
//! @return	TRUE	u
//! @return	FALSE	̑
//!
//! @verbatim
//! ̊֐͑uԕύXɑSĂ̗UްXV܂B
//! @endverbatim
//!
Bool fat_check_device (void)
{
	U8 retry=0;
#if (FS_NB_NAVIGATOR > 1)
	U8 i;
#endif
	Ctrl_status status;

	// ި𖳎\Bǂ/ɎԂ邽߂Ɏgp
	if( g_b_no_check_disk )
		return TRUE;

	if( 0xFF == fs_g_nav.u8_lun )
	{
		fs_g_status = FS_ERR_HW;
		return FALSE;						// IꂽuȂ
	}

	for( retry=0 ; retry<100 ; retry++ )
	{
		// u
		status = mem_test_unit_ready( fs_g_nav.u8_lun );
		if( CTRL_GOOD == status )
			return TRUE;					// ײޏ

		//* ُ͈܂͏ԕω
		// ̑ugpSUް
		fs_g_nav_fast.u8_type_fat = FS_TYPE_FAT_UNM;	// ɂFAT͐tȂ
		Fat_file_close();								// ɂ̧يJȂB
#if (FS_NB_NAVIGATOR > 1)
		for( i=0 ; i!=(FS_NB_NAVIGATOR-1) ; i++ )
		{
			if( fs_g_nav.u8_lun == fs_g_navext[i].u8_lun )
			{
				fs_g_navext_fast[i].u8_type_fat   = FS_TYPE_FAT_UNM;	// ɂFAT͐tȂ
				fs_g_navext_entry[i].u8_open_mode = 0;					// ɂ̧يJȂB
			}
		}
#endif
		// uɑΉ̏ꍇɂ
		if( fs_g_nav.u8_lun == fs_g_sectorcache.u8_lun )
		{
			fat_cache_reset();
		}
		fat_cache_clusterlist_reset();

		fs_g_status = FS_ERR_HW;			// ɂʰ޳ُ
		if( CTRL_BUSY == status )
			continue;						// uZȂAĎs

		if( CTRL_NO_PRESENT == status )
			fs_g_status = FS_ERR_HW_NO_PRESENT;	// ُ׸ލXV
		break;									// FAIL܂NOT PRESENT=vIȈُ=ĎsȂ
	}
	return FALSE;
}

//! ̊֐߰è݂tĂ邩𒲂ׂ܂B
//!
//! @return	TRUE	߰èݐt
//! @return	FALSE	̑
//!
Bool fat_check_mount (void)
{
	if( !fat_check_device() )
		return FALSE;
	if (FS_TYPE_FAT_UNM == fs_g_nav_fast.u8_type_fat)
	{
		if( !fat_mount() )
		{
			fs_g_status = FS_ERR_NO_MOUNT;
			return FALSE;
		}
	}
	return TRUE;
}

//! ̊֐݂̗͌U̧قJĂȂ𒲂ׂ܂B
//!
//! @return	TRUE	Jꂽ̧قȂ
//! @return	FALSE	̑
//!
Bool fat_check_noopen (void)
{
	if( !fat_check_device() )
		return TRUE;
	if (FS_TYPE_FAT_UNM == fs_g_nav_fast.u8_type_fat)
		return TRUE;
	if( Fat_file_is_open() )
	{
		fs_g_status = FS_ERR_TOO_FILE_OPEN;	// U͊ɊJꂽ̧ق܂B
		return FALSE;
	}
	return TRUE;
}

//! ̊֐݂̗͌U̧قJĂ邩𒲂ׂ܂B
//!
//! @return	TRUE	̧قJĂ܂B
//! @return	FALSE	̑
//!
Bool fat_check_open (void)
{
	if( Fat_file_isnot_open() )
	{
		fs_g_status = FS_ERR_FILE_NO_OPEN;
		return FALSE;
	}
	return TRUE;
}

//! ̊֐݂̗͌U̧قIĂ邩𒲂ׂ܂B
//!
//! @return	TRUE	̧قIĂ܂B
//! @return	FALSE	̑
//!
Bool fat_check_select (void)
{
	if (FS_NO_SEL == fs_g_nav_fast.u16_entry_pos_sel_file)
	{
		fs_g_status = FS_ERR_NO_FILE_SEL;
		return FALSE;
	}
	return TRUE;
}

//! ̊֐߰è݂ţقJĂȂ𒲂ׂ܂B
//!
//! @return	TRUE	߰èݐţقJĂ܂B
//! @return	FALSE	̑
//!
Bool fat_check_mount_noopen (void)
{
	if( !fat_check_mount() )
		return FALSE;
	return fat_check_noopen();
}

//! ̊֐߰è݂tA̧قJĂȂA̧قIĂȂ𒲂ׂ܂B
//!
//! @return	TRUE	߰èݐtA̧قJĂȂA̧قIĂ܂B
//! @return	FALSE	̑
//!
Bool fat_check_mount_select_noopen (void)
{
	if( !fat_check_mount() )
		return FALSE;
	if( !fat_check_select() )
		return FALSE;
	return fat_check_noopen();
}

//! ̊֐߰è݂tĂ邩ƁA̧قJĂ邩𒲂ׂ܂B
//!
//! @return	TRUE	߰èݐtA̧قJĂ܂B
//! @return	FALSE	̑
//!
Bool fat_check_mount_select_open (void)
{
	if( !fat_check_mount() )
		return FALSE;
	if( !fat_check_select() )
		return FALSE;
	return fat_check_open();
}

//! ̊֐߰è݂tĂ邩ƁA̧قIĂ邩𒲂ׂ܂B
//!
//! @return	TRUE	߰è݂ţقIĂ܂B
//! @return	FALSE	̑
//!
Bool fat_check_mount_select (void)
{
	if( !fat_check_mount() )
		return FALSE;
	return fat_check_select();
}

//! ̊֐͑I̧̧ٓقިڸ؂łȂ𒲂ׂ܂B
//!
//! @return	TRUE	̧قިڸ؂ł͂܂B
//! @return	FALSE	̑
//!
Bool fat_check_is_file (void)
{
	if( Fat_is_not_a_file )
	{
		fs_g_status = FS_ERR_NO_FILE;		// ̧قł͂ȂAިڸ؂܂حIDłB
		return FALSE;
	}
	return TRUE;
}

#if (FS_MULTI_PARTITION  ==  ENABLED)
//! ̊֐݂͌ި߰èݐԂ܂B
//!
//! @return	u8_number	߰èݐ
//!
U8 fat_get_nbpartition (void)
{
	if( !fat_check_device() )
		return 0;

#warning this routine contains bug, rework it
	// ײނ̐擪ǂݍ
	fs_gu32_addrsector = 0;
	if( !fat_cache_read_sector( TRUE ))
		return FALSE;

	// PBR܂MBR[
	if ( (fs_g_sector[510] != FS_BR_SIGNATURE_LOW  )
	  && (fs_g_sector[511] != FS_BR_SIGNATURE_HIGH ) )
	{
		// MBRȂ
		// ̾PBR?
		if ( (fs_g_sector[0] == 0xEB) &&			// PBR޲0
			 (fs_g_sector[2] == 0x90) &&			// PBR޲2
			((fs_g_sector[21] & 0xF0) == 0xF0) )	// PBR޲21 : }޲
		{
			return 1;						// MBRȂAǂPBR݁A1߰è݂̂
		} else {
			return 0;						// MBRȂAPBRȂA߰è݂ȂB
		}
	}

	number_part = 0;
	while( 1 )
	{
		// 擪MBRłȂ΂Ȃ炸ǍMBR߰èݓ𒲂ׂ܂B
		if ( ((fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(number_part)+0] != FS_PARTITION_ACTIVE) &&
			 (fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(number_part)+0] != 0x00))
		  || (fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(number_part)+4] == 0x00) )
		{
			break;
		}
		number_part++;
	}
	return number_part;
}
#endif

//! ̊֐͸׽ꗗ擾܂͉܂B
//!
//! @param	b_for_file	TRUEȂ̧ ׽ꗗAłȂިڸ ׽ꗗ<br>
//! @param	opt_action	׽ꗗł̊I<br>
//!						FS_CLUST_ACT_SEG ׽ꗗɑΉp Ă擾<br>
//!						FS_CLUST_ACT_ONE ׽ꗗɑΉ1 (512޲)擾<br>
//!						FS_CLUST_ACT_CLR ׽ꗗ<br>
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_seg.u32_addr			׽ꗗ̐擪׽
//!   fs_g_seg.u32_size_or_pos	ꗗ̊Jnʒu(512޲ĒP)
//! OUT:
//!   fs_g_seg.u32_addr			׽ꗗ̐擪ɑΉ  ڽ(FS_CLUST_ACT_SEGFS_CLUST_ACT_ONE̊ɑ΂Ă̂)
//!   fs_g_seg.u32_size_or_pos	ǂ܂ꂽ܂͉ꂽ׽ꗗɑΉ ėe(512޲ĒP)
//! @endverbatim
//!
Bool fat_cluster_list (U8 opt_action, Bool b_for_file)
{
	_MEM_TYPE_FAST_ U32 u32_tmp;
	_MEM_TYPE_FAST_ U8 u8_cluster_status;

	fs_g_status = FS_ERR_FS;				// ɂļшُ

	if(  Is_fat32
	  && (FS_CLUST_ACT_CLR == opt_action) )
	{
#if (FSFEATURE_WRITE_COMPLET == (FS_LEVEL_FEATURES & FSFEATURE_WRITE_COMPLET) )
		// FAT32̋󂫋ԏL
		if( !fat_write_fat32_FSInfo( 0xFFFFFFFF ))
			return FALSE;
#else
		return FALSE;
#endif
	}

	if ( 0 == fs_g_seg.u32_addr )
	{
		// ٰ ިڸ؂̸׽ꗗ
		if( FS_CLUST_ACT_CLR == opt_action )
			return FALSE;					// ٰ ިڸ؏s

		if ( Is_fat12 || Is_fat16 )
		{
			// FAT1216ɑ΂āAٰ ިڸ؂͸׽ꗗł͂܂B
			// ʒu
			if ( fs_g_seg.u32_size_or_pos < fs_g_nav.rootdir.seg.u16_size )
			{
				// JnڽƑ傫vZ
				fs_g_seg.u32_addr = fs_g_nav.u32_ptr_fat + fs_g_nav.rootdir.seg.u16_pos + fs_g_seg.u32_size_or_pos;
				fs_g_seg.u32_size_or_pos = fs_g_nav.rootdir.seg.u16_size - fs_g_seg.u32_size_or_pos;
				return TRUE;
			} else {
				fs_g_status = FS_ERR_OUT_LIST;
				return FALSE;				// ٰė̈Öʒu
			}
		}
		if ( Is_fat32 )
		{
			// FAT32ɑ΂āAٰĂ͸׽ꗗŁA擪׽͐tɓǂ݂܂B
			fs_g_cluster.u32_pos = fs_g_nav.rootdir.u32_cluster;
		}
	} else {
		// ͸׽ꗗ̐擪׽łB
		fs_g_cluster.u32_pos = fs_g_seg.u32_addr;
	}

	// ׽ꗗ̊Ǘ
	if( FS_CLUST_ACT_CLR != opt_action )
	{
		if( fat_cache_clusterlist_update_read( b_for_file ) )
			return TRUE;					// žĔ
		// ĖAXV̂߂̷
	}else{
		fat_cache_clusterlist_reset();		// A׽ꗗ
#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
		fat_clear_info_fat_mod();			// FATύX͈͂ŷ
#endif // FS_LEVEL_FEATURES
	}

	// ȂJnĂJԂ
	MSB0( fs_g_seg.u32_addr ) = 0xFF;

	//**** ׽ꗗǂނ߂̌JԂ
	while ( 1 )
	{
		if ( fs_g_seg.u32_size_or_pos < fs_g_nav.u8_BPB_SecPerClus )
		{
			// Ă̸͂׽ŊJn
			// ̸׽̾ ڽvZ
			fs_g_seg.u32_addr = ((fs_g_cluster.u32_pos - 2) * fs_g_nav.u8_BPB_SecPerClus)
								+ fs_g_nav.u32_ptr_fat + fs_g_nav.u32_offset_data + fs_g_seg.u32_size_or_pos;

			if ( FS_CLUST_ACT_ONE == opt_action )
			{
				// őeʂvZ
				fs_g_seg.u32_size_or_pos = fs_g_nav.u8_BPB_SecPerClus-fs_g_seg.u32_size_or_pos;
				fat_cache_clusterlist_update_finish();
				// 1̑傫𑗏o
				fs_g_seg.u32_size_or_pos = 1;
				return TRUE;
			}
			// ėeʂXV
			fs_g_seg.u32_size_or_pos = fs_g_nav.u8_BPB_SecPerClus - LSB0( fs_g_seg.u32_size_or_pos );

			// FAT1632ł̸׽ꗗǂݍݒɎԂ܂B
			if( (FS_CLUST_ACT_SEG == opt_action)
			 && (!Is_fat12) )
			{
				// ̸݂׽ł̌JԂ
				u32_tmp = fs_g_cluster.u32_pos;
				if( !fat_cluster_val( FS_CLUST_VAL_READ ))
					return FALSE;
				// ׽ꗗǂݍ݁Aɂ͌p
				while(1)
				{
					if ( (++fs_g_cluster.u32_pos) != fs_g_cluster.u32_val )
					{
						fs_g_cluster.u32_pos--;						// O̒lČvZ
						u32_tmp = fs_g_cluster.u32_pos - u32_tmp;	// ׽ꗗ̑傫vZ
						fs_g_seg.u32_size_or_pos += u32_tmp * fs_g_nav.u8_BPB_SecPerClus;
						break;
					}
					if( !fat_cluster_readnext() )
						return FALSE;
				}
			}
		}
		// ׽l擾
		if( !fat_cluster_val( FS_CLUST_VAL_READ ))
			return FALSE;

		// V׽̏Ԃ̓ǂݍ݂ƌ
		u8_cluster_status = fat_checkcluster();
		if (FS_CLUS_BAD == u8_cluster_status)
			return FALSE;					// ُAꗗ̏I

		if (0xFF == MSB0(fs_g_seg.u32_addr))
		{
			// Ă̐擪ȂB
			if (FS_CLUS_END == u8_cluster_status)
			{
				u32_tmp = fs_g_seg.u32_size_or_pos;		// c̾ۑ

				// ׽ꗗł̗̏vɎԂ邽߁A̍Ō̸׽̾ ڽvZ
				fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_start -= fs_g_seg.u32_size_or_pos;
				fs_g_seg.u32_addr = ((fs_g_cluster.u32_pos - 2) * fs_g_nav.u8_BPB_SecPerClus)
									+ fs_g_nav.u32_ptr_fat + fs_g_nav.u32_offset_data;
				fs_g_seg.u32_size_or_pos = fs_g_nav.u8_BPB_SecPerClus;
				if (FS_CLUST_ACT_CLR != opt_action)
					fat_cache_clusterlist_update_finish();
				// ̈ʒu͸׽ꗗ̊O
				fs_g_seg.u32_addr = fs_g_cluster.u32_pos;	// Ō̸׽l𑗂B
				fs_g_seg.u32_size_or_pos = u32_tmp;			// c̾𕜋A
				fs_g_status = FS_ERR_OUT_LIST;
				return FALSE;
			}
			// ǍDȸ׽Ap
			fs_g_seg.u32_size_or_pos -= fs_g_nav.u8_BPB_SecPerClus;
#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
			if (FS_CLUST_ACT_CLR == opt_action)
			{
				if( fs_g_seg.u32_size_or_pos == 0)
				{
					// ׽ʒuŁA׽ꗗ̏I׸ނݒ
					fs_g_seg.u32_addr = fs_g_cluster.u32_val;	// ̸׽ۑ
					fs_g_cluster.u32_val = FS_CLUST_VAL_EOL;
					if( !fat_cluster_val( FS_CLUST_VAL_WRITE ))
						return FALSE;
					fs_g_cluster.u32_val = fs_g_seg.u32_addr;	// ̸׽𕜋A
					// !!!! MSB0(fs_g_seg.u32_addr)0xFFɍďKv͂܂B
					// !!!! fs_g_seg.u32_addr͎JԂ̐擪ŕύX܂B
				}
			}
#endif  // FS_LEVEL_FEATURES
		}
		else
		{
			// Ă̐擪ȂB
			if (FS_CLUST_ACT_SEG == opt_action)
			{
				if ( (fs_g_cluster.u32_pos+1) != fs_g_cluster.u32_val )
				{
					// ׽͌p׽łȂA܂͖ȸ׽
					fat_cache_clusterlist_update_finish();
					return TRUE;			// Ă̏I
				}
			}
#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
			if (FS_CLUST_ACT_CLR == opt_action)
			{
				//** ׽ʒu
				fs_g_seg.u32_addr = fs_g_cluster.u32_val;	// ̸׽ۑ
				fs_g_cluster.u32_val = 0;					// ɂċ󂫸׽
				// ꂪŏ̸׽ȂA(fs_g_seg.u32_size_or_pos <= fs_g_nav.u8_BPB_SecPerClus)
				// ׽̐擪ŊJn܂(fs_g_seg.u32_size_or_pos != fs_g_nav.u8_BPB_SecPerClus)B
				if (fs_g_seg.u32_size_or_pos < fs_g_nav.u8_BPB_SecPerClus)
				{
					fs_g_cluster.u32_val = FS_CLUST_VAL_EOL;	// 蓖Ăꂽ׽ꗗ̏I
				}
				if( !fat_cluster_val( FS_CLUST_VAL_WRITE ))
					return FALSE;
				fs_g_cluster.u32_val = fs_g_seg.u32_addr;	// ̸׽𕜋A
				// !!!! MSB0(fs_g_cluster.val)=0xFFs\Ȃ߁A
				// !!!! MSB0(fs_g_seg.u32_addr)0xFFōďKv͂܂B
			}
#endif // FS_LEVEL_FEATURES

			// ׽ꗗ̏I茟
			if (FS_CLUS_END == u8_cluster_status)
			{
#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
				if (FS_CLUST_ACT_CLR == opt_action)
				{
					return fat_update_fat2();
				}
#endif // FS_LEVEL_FEATURES
				fat_cache_clusterlist_update_finish();
				return TRUE;				// Ă̏I
			}

			// ėeʍXV
			fs_g_seg.u32_size_or_pos += fs_g_nav.u8_BPB_SecPerClus;
		}
		// ŁA׽ꗗǂݍ݂p
		// ̸׽͒O׽̒lłB
		fs_g_cluster.u32_pos = fs_g_cluster.u32_val;
	} // mainJԂ̏I
}

//! \name FAŤ̸݂׽̈ʒu<br>
//! fat_cluster_readnext()fat_cluster_val()ٰ݂ŎԂ邽߂ɎgpSϐ
_MEM_TYPE_FAST_ U16 fs_g_u16_pos_fat;

//! ̊֐FAT̸׽lԂA܂͕ύX܂B
//!
//! @param	b_mode	׽lǂݍ݂̂߂ɂFALSE<br>
//!					׽l݂̂߂ɂTRUE
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_cluster.u32_pos	ǂ݂܂͏׽ԍ
//!   fs_g_cluster.u32_val	l
//! OUT:
//!   fs_g_cluster.u32_val	ǂ񂾒l
//!   fs_g_u16_pos_fat		fat_cluster_readnext()ٰ݂gpꂽ̏ꍇɏǂ݂܂͏邽߂̸׽FATʒu
//! @endverbatim
//!
Bool fat_cluster_val (Bool b_mode)
{
	_MEM_TYPE_FAST_ U16 u16_offset_fat;
	_MEM_TYPE_FAST_ U8  u8_data1, u8_data2;
#define u8_data3	(LSB(u16_offset_fat))	// 蓮㏑
#define u8_data4	(MSB(u16_offset_fat))	// 蓮㏑
	_MEM_TYPE_FAST_ PTR_CACHE u8_ptr_cluster;

	//**** FAT̸׽ʒuvZ( ڽƾʒu)
	if ( Is_fat32 )
	{
		// FAT 32
		// u16_offset_fat = fs_g_cluster.pos~4/FS_CACHE_SIZE; ̍œK
		// u16_offset_fat = fs_g_cluster.pos/128 ̍œK
		u16_offset_fat = fs_g_cluster.u32_pos >> (8-1);

		// Ofs_g_u16_pos_fat = (fs_g_cluster.u32_pos~4) % FS_CACHE_SIZE; ̍œK
		// fs_g_u16_pos_fat = (fs_g_cluster.u32_pos % 128)~4 ̍œK
		fs_g_u16_pos_fat = ((U16)(LSB0(fs_g_cluster.u32_pos) & 0x7F))<< 2;
	}
	else if ( Is_fat16 )
	{
		// FAT 16
		// u16_offset_fat = fs_g_cluster.u32_pos~2/FS_CACHE_SIZE = fs_g_cluster.u32_pos/256; ̍œK
		u16_offset_fat = LSB1(fs_g_cluster.u32_pos);
		// fs_g_u16_pos_fat = (fs_g_cluster.u32_pos~2) % FS_CACHE_SIZE; ̍œK
		// fs_g_u16_pos_fat = (fs_g_cluster.u32_pos % 256)~2 ̍œK
		fs_g_u16_pos_fat = ((U16)LSB0(fs_g_cluster.u32_pos)) <<1;
	}
	else if ( Is_fat12 )
	{
		// FAT 12
		// fs_g_u16_pos_fat = fs_g_cluster.u32_pos + (fs_g_cluster.u32_pos/ 2) ̍œK
		fs_g_u16_pos_fat = (U16)fs_g_cluster.u32_pos + ((U16)fs_g_cluster.u32_pos >>1);
		// u16_offset_fat = fs_g_cluster.u32_pos / FS_CACHE_SIZE ̍œK
		u16_offset_fat = MSB(fs_g_u16_pos_fat) >> 1;
		// fs_g_u16_pos_fat = fs_g_u16_pos_fat % FS_CACHE_SIZE ̍œK
		MSB( fs_g_u16_pos_fat ) &= 0x01;
	}

#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
	if (b_mode)
	{
		// FATύXɂĂ̏XV
		if( fs_g_u16_first_mod_fat > u16_offset_fat )
		{
			fs_g_u16_first_mod_fat = u16_offset_fat;
		}
		if( fs_g_u16_last_mod_fat < u16_offset_fat )
		{
			fs_g_u16_last_mod_fat = u16_offset_fat;
		}
		if ( Is_fat12 )
		{  // ׽2̾Ŋi[꓾܂B
			if( fs_g_u16_pos_fat == (FS_CACHE_SIZE-1) )
			{  // FAT𐔂B
				if( fs_g_u16_last_mod_fat < (u16_offset_fat+1) )
				{
					fs_g_u16_last_mod_fat = (u16_offset_fat+1);
				}
			}
		}
	}
#endif // FS_LEVEL_FEATURES

	//**** FAT̸׽ ǂݍ
	fs_gu32_addrsector = fs_g_nav.u32_ptr_fat + u16_offset_fat;		// vZꂽ_ ڽ
	if( !fat_cache_read_sector( TRUE ))
		return FALSE;

	// ׽ǂݍ
	u8_ptr_cluster = &fs_g_sector[fs_g_u16_pos_fat];
	u8_data1 = u8_ptr_cluster[0];
	// :(fs_g_u16_pos_fat+1)=512ȂA̒l̍s邽ߌł͂܂B
	u8_data2 = u8_ptr_cluster[1];
	u8_data3 = u8_ptr_cluster[2];
	u8_data4 = u8_ptr_cluster[3];

	if ( Is_fat12 )
	{	// ׽2̾Ŋi[꓾܂B
		if(  fs_g_u16_pos_fat == (FS_CACHE_SIZE-1) )
		{	// ֍sB
			fs_gu32_addrsector++;
			if( !fat_cache_read_sector( TRUE ))
				return FALSE;
			u8_data2 = fs_g_sector[0];
		}
	}

	if (FALSE == b_mode)
	{
		//**** ׽lǂݍ
		LSB0( fs_g_cluster.u32_val ) = u8_data1;	// FAT12/16/32
		LSB1( fs_g_cluster.u32_val ) = u8_data2;	// FAT12/16/32

		if ( Is_fat32 )
		{	// FAT32
			LSB2( fs_g_cluster.u32_val ) = u8_data3;
			LSB3( fs_g_cluster.u32_val ) = u8_data4 & 0x0F;		// 4ޯĂ͗\
		}
		else
		{	// FAT1216͏޲Ăgp܂B
			LSB2( fs_g_cluster.u32_val ) = 0;
			LSB3( fs_g_cluster.u32_val ) = 0;

			// FAT1216ޯĒl12ޯĂɕϊ܂B
			if ( Is_fat12 )
			{
				if ( 0x01 & LSB0(fs_g_cluster.u32_pos) )
				{  // ǂ񂾸׽͊
					LSB0( fs_g_cluster.u32_val ) = (LSB1( fs_g_cluster.u32_val ) <<4 ) + (LSB0( fs_g_cluster.u32_val ) >>4 );
					LSB1( fs_g_cluster.u32_val ) =  LSB1( fs_g_cluster.u32_val ) >>4 ;
				}
				else
				{  // ǂ񂾸׽͋
					LSB1( fs_g_cluster.u32_val ) &= 0x0F;
				}
			}
		}
	} else {
#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
		//**** ׽l
		if ( Is_fat12 )
		{
			// FAT12A׽lϊ
			if ( 0x01 & LSB0(fs_g_cluster.u32_pos) )
			{	// ׽݂͊
				u8_data1 = (u8_data1 & 0x0F) + (LSB0( fs_g_cluster.u32_val )<<4);
				u8_data2 = (LSB1( fs_g_cluster.u32_val )<<4) + (LSB0( fs_g_cluster.u32_val )>>4) ;
			} else {
				// ׽݂͋
				u8_data1 = LSB0( fs_g_cluster.u32_val );
				u8_data2 = (u8_data2 & 0xF0) + (LSB1( fs_g_cluster.u32_val ) & 0x0F) ;
			}

			// ׽2̾Ŋi[꓾܂B
			if( fs_g_u16_pos_fat == (FS_CACHE_SIZE-1) )
			{
				fs_g_sector[0] = u8_data2;
				fat_cache_mark_sector_as_dirty();
				// O֍sB
				fs_gu32_addrsector--;
				if( !fat_cache_read_sector( TRUE ))
					return FALSE;
				// OύX
				fs_g_sector[ FS_CACHE_SIZE-1 ] = u8_data1;
				fat_cache_mark_sector_as_dirty();
				return TRUE;
			}
		}
		else
		{
			// FAT1632
			u8_data1 = LSB0( fs_g_cluster.u32_val );
			u8_data2 = LSB1( fs_g_cluster.u32_val );
			if ( Is_fat32 )
			{	// FAT32
				u8_ptr_cluster[2] = LSB2( fs_g_cluster.u32_val );
				u8_ptr_cluster[3] = LSB3( fs_g_cluster.u32_val ) + (u8_data4 & 0xF0);	// 4ޯĂ͗\
			}
		}
		// ŁAFAT12/16/32ɑ΂(׽l̏ꍇ)
		u8_ptr_cluster[0] = u8_data1;
		u8_ptr_cluster[1] = u8_data2;
		fat_cache_mark_sector_as_dirty();
#else
		fs_g_status = FS_ERR_COMMAND;
		return FALSE;
#endif // FS_LEVEL_FEATURES
	}

	return TRUE;
#undef u8_data3								// 蓮㏑̏I
#undef u8_data4								// 蓮㏑̏I
}

//! ̊֐FAT16FAT32Ōp׽ꗗǂݍ݂œK܂B
//!
//! ُ̏ꍇ"fs_g_status"SlǂłB
//!			FS_ERR_HW	ʰ޳ ײވُ
//!			FS_LUN_WP	ײނǂݍݐp
//!
//! @return	FALSE		ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE		̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_u16_pos_fat		FAT̒O׽ʒu
//! OUT:
//!   fs_g_u16_pos_fat		FATœǂ܂ꂽ׽ʒu
//!   fs_g_cluster.u32_val	ǂ܂ꂽ׽̒l
//! @endverbatim
//!
Bool fat_cluster_readnext (void)
{
	// FAT̸̎׽ʒuvZ
	if ( Is_fat32 )
	{
		fs_g_u16_pos_fat += 4;
	}else{
		// Is_fat16
		fs_g_u16_pos_fat += 2;
	}

	// ̸׽
	if( FS_CACHE_SIZE == fs_g_u16_pos_fat )
	{
		// XV
		fs_g_u16_pos_fat = 0;
		fs_gu32_addrsector++;
		if( !fat_cache_read_sector( TRUE ))
			return FALSE;
	}

	//**** ׽lǂݍ
	LSB0( fs_g_cluster.u32_val ) = fs_g_sector[fs_g_u16_pos_fat+0];		// FAT16/32
	LSB1( fs_g_cluster.u32_val ) = fs_g_sector[fs_g_u16_pos_fat+1];		// FAT16/32

	if ( Is_fat32 )
	{	// FAT32
		LSB2( fs_g_cluster.u32_val ) = fs_g_sector[fs_g_u16_pos_fat+2];
		LSB3( fs_g_cluster.u32_val ) = fs_g_sector[fs_g_u16_pos_fat+3];
	}
	return TRUE;
}

//! ̊֐͸׽l𒲂ׂ܂B
//!
//! @return	Ԓl<br>
//!			FS_CLUS_OK		l<br>
//!			FS_CLUS_BAD		ʖڒl<br>
//!			FS_CLUS_END		ꗗ̍Ō<br>
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_cluster.u32_val	̂߂̒l
//! @endverbatim
//!
U8 fat_checkcluster (void)
{
	if ( !fs_g_cluster.u32_val )
		return FS_CLUS_BAD;

	// (FAT12=0x0FF7)A(FAT16=0xFFF7)A(FAT32=0x0FFFFFF7)ȂA׽s
	// (FAT12>0x0FF7)A(FAT16>0xFFF7)A(FAT32>0x0FFFFFF7)ȂAŌ̸
	if ( Is_fat32 )
	{
		if (fs_g_cluster.u32_val >= 0x0FFFFFF8)
			return FS_CLUS_END;
		else if (fs_g_cluster.u32_val == 0x0FFFFFF7)
			return FS_CLUS_BAD;
	}
	else if ( Is_fat16 )
	{
		if (fs_g_cluster.u32_val >= 0xFFF8)
			return FS_CLUS_END;
		else if (fs_g_cluster.u32_val == 0xFFF7)
			return FS_CLUS_BAD;
	}
	else if ( Is_fat12 )
	{
		if (fs_g_cluster.u32_val >= 0xFF8)
			return FS_CLUS_END;
		else if (fs_g_cluster.u32_val == 0xFF7)
			return FS_CLUS_BAD;
	}

	return FS_CLUS_OK;
}

//! \name ׽ꗗǗ邽߂̓֐
//! @{

//! ̊֐͸׽ꗗؾĂ܂B
//!
void fat_cache_clusterlist_reset (void)
{
	U8 u8_i;
	fs_g_u8_current_cache=0;
	for( u8_i=0; u8_i<(FS_NB_CACHE_CLUSLIST*2); u8_i++ )
	{
		// ꗗ2̷(̧ ׽ꗗިڸ ׽ꗗ)ɕ܂B
		fs_g_cache_clusterlist[u8_i].b_cache_file = (u8_i<FS_NB_CACHE_CLUSLIST)?TRUE:FALSE;
		fs_g_cache_clusterlist[u8_i].u8_lun = 0xFF;
		fs_g_cache_clusterlist[u8_i].u8_level_use = 0xFF;
	}
}

//! ̊֐͸׽ꗗŷ܂B
//!
//! @param b_for_file	TRUEȂ̧ ׽ꗗAȂިڸ ׽ꗗłB<br>
//!
void fat_cache_clusterlist_update_start (Bool b_for_file)
{
	// (=gpꂽő)擾
	U8 u8_i;
	for( u8_i=0; u8_i<((FS_NB_CACHE_CLUSLIST*2)-1); u8_i++ )	// ُ̏ꍇA(FS_NB_CACHE_CLUSLIST*2)-1
	{
		if( fs_g_cache_clusterlist[u8_i].b_cache_file == b_for_file )
		{
#if (FS_NB_CACHE_CLUSLIST>1)
			if( (FS_NB_CACHE_CLUSLIST-2) < fs_g_cache_clusterlist[u8_i].u8_level_use )
#endif
			break;
		}
	}
	fs_g_u8_current_cache = u8_i;
	fs_g_cache_clusterlist[fs_g_u8_current_cache].b_cache_file = b_for_file;
	fs_g_cache_clusterlist[fs_g_u8_current_cache].u8_lun       = 0xFF;		// 
	fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_cluster  = fs_g_cluster.u32_pos;
	fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_start    = fs_g_seg.u32_size_or_pos;
}

//! ̊֐͸׽ꗗ̷XV܂B
//!
void fat_cache_clusterlist_update_finish (void)
{
	U8 u8_cluster_offset = fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_start % fs_g_nav.u8_BPB_SecPerClus;
	fs_g_cache_clusterlist[fs_g_u8_current_cache].u8_lun     = fs_g_nav.u8_lun;  
	fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_start -= u8_cluster_offset;
	fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_addr   = fs_g_seg.u32_addr - u8_cluster_offset;
	fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_size   = fs_g_seg.u32_size_or_pos + u8_cluster_offset;

	// "gpς"XV
	fat_cache_clusterlist_update_select();
}

//! ̊֐ͷgpꂽƂ}܂B
//!
void fat_cache_clusterlist_update_select (void)
{
	U8 u8_i;
	U8 u8_level_to_update;
	Bool b_file_cache;

	b_file_cache       = fs_g_cache_clusterlist[ fs_g_u8_current_cache ].b_cache_file;
	u8_level_to_update = fs_g_cache_clusterlist[ fs_g_u8_current_cache ].u8_level_use;
	for( u8_i=0; u8_i<(FS_NB_CACHE_CLUSLIST*2); u8_i++ )
	{
		if( fs_g_cache_clusterlist[u8_i].b_cache_file == b_file_cache )
			if( u8_level_to_update > fs_g_cache_clusterlist[u8_i].u8_level_use )
				fs_g_cache_clusterlist[u8_i].u8_level_use++;
	}
	fs_g_cache_clusterlist[  fs_g_u8_current_cache  ].u8_level_use = 0;
}

//! ̊֐͸׽ꗗŸ׽ꗗ܂B
//!
//! @param	b_for_file	TRUEȂ̧ ׽ꗗAȂިڸ ׽ꗗłB<br>
//!
//! @return	TRUE		׽ꗗAfs_g_segSϐXV
//! @return	FALSE		׽ꗗ
//!
Bool fat_cache_clusterlist_update_read (Bool b_for_file)
{
	U32 u32_tmp;
	U8 u8_i;
	for( u8_i=0; u8_i<(FS_NB_CACHE_CLUSLIST*2); u8_i++ )
	{
		if( (fs_g_cache_clusterlist[u8_i].b_cache_file == b_for_file)
		 && (fs_g_cache_clusterlist[u8_i].u8_lun == fs_g_nav.u8_lun ) )
		{
			if( fs_g_cache_clusterlist[u8_i].u32_cluster == fs_g_cluster.u32_pos )
			{
				if( fs_g_cache_clusterlist[u8_i].u32_start <= fs_g_seg.u32_size_or_pos )
				{
					// Ēͷ̓܂͌
					if( fs_g_cache_clusterlist[u8_i].u32_size  > (fs_g_seg.u32_size_or_pos-fs_g_cache_clusterlist[u8_i].u32_start) )
					{
						//** ĒͷǍɾďvZ
						fs_g_seg.u32_size_or_pos -= fs_g_cache_clusterlist[u8_i].u32_start;
						fs_g_seg.u32_addr = fs_g_cache_clusterlist[u8_i].u32_addr + fs_g_seg.u32_size_or_pos;
						fs_g_seg.u32_size_or_pos = fs_g_cache_clusterlist[u8_i].u32_size - fs_g_seg.u32_size_or_pos;
						fs_g_u8_current_cache = u8_i;
						fat_cache_clusterlist_update_select();
						return TRUE;		// Ă͸׽ꗗłB
					}else{
						//** ȂA𓾂FATŸ׽ꗗǂݍ݂p܂B
						// ̷̌ʂi[
						fs_g_u8_current_cache = u8_i;
						fs_g_cache_clusterlist[fs_g_u8_current_cache].u8_lun		= 0xFF;						// 
//						fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_cluster	= fs_g_cluster.u32_pos;		// Jn׽

						// FATɎԂ邽߁A擾
						// ׽ꗗ̍Ō̸׽ɑΉԍvZ
						fs_g_cluster.u32_pos = ((fs_g_cache_clusterlist[u8_i].u32_addr -fs_g_nav.u32_ptr_fat - fs_g_nav.u32_offset_data + fs_g_cache_clusterlist[u8_i].u32_size -1)
											   / fs_g_nav.u8_BPB_SecPerClus) +2;
						u32_tmp  = fs_g_seg.u32_size_or_pos;								// ꂽʒuۑ
						// ׽ꗗ̍Ō̈ʒuvZAꂽʒu
						fs_g_seg.u32_size_or_pos-= ((fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_start + fs_g_cache_clusterlist[u8_i].u32_size -1)
												 / fs_g_nav.u8_BPB_SecPerClus)
												 * fs_g_nav.u8_BPB_SecPerClus;
						fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_start = u32_tmp;	// ꂽʒuŷXV
						return FALSE;														// Ă͸׽ ł͂܂B
					}
				}
			}
		}
	}
	// Ō炸AFATǂŷɌʂi[
	fat_cache_clusterlist_update_start(b_for_file);
	return FALSE;
}

//! @}

//! ̊֐͑I̧݈ٓ̌ʒuŸ׽ꗗ擾܂͉
//!
//! @param	mode	I<br>
//!					FS_CLUST_ACT_SEG	I̧ٓ̈ʒuɑΉ Ă擾<br>
//!					FS_CLUST_ACT_ONE	I̧ٓ̈ʒuɑΉ龸Ŋi[<br>
//!					FS_CLUST_ACT_CLR	I̧ٓ̈ʒuɑΉ׽ꗗ<br>
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_nav_entry.u32_cluster		I̧ق̐擪׽
//!   fs_g_nav_entry.u32_pos_in_file	̧ق̈ʒu(޲ĒP)
//! @endverbatim
//!
Bool fat_read_file (U8 mode)
{
	U32 u32_sector_pos;

	// ʒuvZ
	u32_sector_pos = fs_g_nav_entry.u32_pos_in_file >> FS_512B_SHIFT_BIT;

	if(FS_CLUST_ACT_ONE  == mode)
	{
		if( (fs_g_sectorcache.u8_lun                == fs_g_nav.u8_lun )
		 && (fs_g_sectorcache.u32_clusterlist_start == fs_g_nav_entry.u32_cluster )
		 && (fs_g_sectorcache.u32_clusterlist_pos   == u32_sector_pos ) )
		{
			return TRUE;					// ͖ꂽ܂݂܂B
		}
	}
	else
	{
		if( FS_CLUST_ACT_CLR == mode )
		{
			// ׽ꗗ
			if( 0 == fs_g_nav_entry.u32_cluster )
				return TRUE;				// ׽ꗗ̧قɌqĂ炸A̕Kv͂܂B

			if(0 != (fs_g_nav_entry.u32_pos_in_file & FS_512B_MASK) )
			{
				// ۂ̾gpA̾ŉJn
				u32_sector_pos++;
			}
		}
	}

	// ݂̈ʒuŎn܂龸Ă擾
	fs_g_seg.u32_addr = fs_g_nav_entry.u32_cluster;
	fs_g_seg.u32_size_or_pos = u32_sector_pos;
	if( FS_CLUST_ACT_ONE != mode )
	{
		if( fat_cluster_list( mode, TRUE ) )
			return TRUE;					// Ă̎擾܂͉OK
	}
	else
	{
		if( fat_cluster_list( FS_CLUST_ACT_SEG, TRUE ) )	// Sēǂݍ
		{
			// ̧وʒuɑΉ龸(=Ă̐擪)ǂݍ
			fs_gu32_addrsector = fs_g_seg.u32_addr ;
			if( fat_cache_read_sector( TRUE ) )
			{
				fs_g_sectorcache.u32_clusterlist_start = fs_g_nav_entry.u32_cluster;
				fs_g_sectorcache.u32_clusterlist_pos   = u32_sector_pos;
				return TRUE;
			}
		}
	}
	if( (FS_CLUST_ACT_CLR == mode       )
	 && (FS_ERR_OUT_LIST  == fs_g_status) )
	{
		// ȂƂ\
		return TRUE;
	}
	 FALSE;
}

#if (FSFEATURE_WRITE == (FS_LEVEL_FEATURES & FSFEATURE_WRITE))
//! ̊֐͑I̧݈ٓ̌ʒuŸ׽ꗗ擾ƌʓIɊ蓖Ă܂B
//!
//! @param	mode				I<br>
//!								FS_CLUST_ACT_SEG	׽ꗗ擾ƌʓIɊ蓖<br>
//!								FS_CLUST_ACT_ONE	1ɑ΂ĸ׽ꗗ擾ƌʓIɊ蓖āAɂ̾ݒ<br>
//! @param	u32_nb_sector_write	I̧قɑ΂Ď擾ƌʓIɊ蓖Ăő徸(mode=FS_CLUST_ACT_ONȄꍇɖ܂B)
//!
//! @return	FALSE				ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE				̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_nav_entry.u32_cluster		I̧ق̐擪׽
//!   fs_g_nav_entry.u32_pos_in_file	̧ٓ̈ʒu(޲ĒP)
//! @endverbatim
//!
Bool fat_write_file (U8 mode, U32 u32_nb_sector_write)
{
	if( 0 == fs_g_nav_entry.u32_cluster )
	{
		// ̧ق׽׈ꗗA̧ق̐擪׽ꗗ蓖
		MSB0(fs_g_seg.u32_addr)	 = 0xFF;	// ͐V׽ꗗłB
		// ׽ꗗXV
//		fs_g_cluster.u32_pos	 = ?		// 蓖Čɖ
		fs_g_seg.u32_size_or_pos   = 0;
		fat_cache_clusterlist_update_start(TRUE);
	}
	else
	{
		if( fat_read_file( mode ) )
			return TRUE;					// Ă͗p\(蓖Ă̕KvȂ)

		if( FS_ERR_OUT_LIST != fs_g_status )
		{
			return FALSE;					// шُ
		}
		// fat_read_file͈ꗗ̊OA̸݂׽ꗗ͍Ō̸׽܂݂܂B

		// 蓖ٰ݌ɸ׽ꗗ
		fs_g_cache_clusterlist[fs_g_u8_current_cache].u8_lun		= 0xFF;							// 
//		fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_cluster	= fs_g_cluster.u32_pos;			// ͓łB
		fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_start	   += fs_g_nav.u8_BPB_SecPerClus;	// ̸׽̈ʒu(ŏ̐VK)
	}

	// ׽ꗗ蓖
	if( FS_CLUST_ACT_SEG == mode )
	{
		fs_g_seg.u32_size_or_pos = u32_nb_sector_write;
	}else{
		fs_g_seg.u32_size_or_pos = 1;		// 1̂
	}

	// :fs_g_seg.u32_addr͊ɍŌ̸׽lŏĂ܂(fat_cluster_list())B
	if( !fat_allocfreespace())
		return FALSE;
	// :fs_g_seg.u32_addralloc_free_space()ɂĊ蓖Ăꂽ׽ꗗ̐擪׽łB
	// :fs_g_seg.u32_size_or_pos=c辸

	if( 0 == fs_g_nav_entry.u32_cluster )
	{
		// ̧ق̐擪׽ꗗȂA׽ꗗ̌㑱lXV
		// fs_g_seg.u32_addr=̧ق̐擪׽܂݂܂(alloc_free_space())B
		fs_g_cache_clusterlist[fs_g_u8_current_cache].u32_cluster = fs_g_seg.u32_addr;
		// ̧ٓXV
		fs_g_nav_entry.u32_cluster = fs_g_seg.u32_addr;
	}

	// ׽ꗗXV
	if( FS_CLUST_ACT_SEG == mode )
	{
		fs_g_seg.u32_size_or_pos = u32_nb_sector_write - fs_g_seg.u32_size_or_pos;
	}else{
		fs_g_seg.u32_size_or_pos = 1 - fs_g_seg.u32_size_or_pos;
	}
	fs_g_seg.u32_addr = ((fs_g_seg.u32_addr - 2) * fs_g_nav.u8_BPB_SecPerClus)
						+ fs_g_nav.u32_ptr_fat + fs_g_nav.u32_offset_data;
	fat_cache_clusterlist_update_finish();

	return fat_read_file( mode );			// V׽ꗗݒ
}
#endif // FS_LEVEL_FEATURES

//! ̊֐݂͌ިڸ؂Ŗ܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_nav.u32_cluster_sel_dir			݂ިڸ؂̐擪׽
//!   fs_g_nav_fast.u16_entry_pos_sel_file	ިڸؓ̈ʒu(P)
//! @endverbatim
//!
Bool fat_read_dir (void)
{
	U32 u32_cluster_pos;

	// ݂̓ɑΉ׽ꗗʒuvZ
	u32_cluster_pos = fs_g_nav_fast.u16_entry_pos_sel_file >> (FS_512B_SHIFT_BIT - FS_SHIFT_B_TO_FILE_ENTRY);

	if( (fs_g_sectorcache.u8_lun                == fs_g_nav.u8_lun )
	 && (fs_g_sectorcache.u32_clusterlist_start == fs_g_nav.u32_cluster_sel_dir )
	 && (fs_g_sectorcache.u32_clusterlist_pos   == u32_cluster_pos ) )
	{
		return TRUE;						// ͖ꂽ܂݂܂B
	}

	// ׽ꗗʒuɑΉ龸 ڽ擾
	fs_g_seg.u32_addr = fs_g_nav.u32_cluster_sel_dir;
	fs_g_seg.u32_size_or_pos = u32_cluster_pos;
	if( fat_cluster_list( FS_CLUST_ACT_ONE, FALSE ) )
	{
		// ǂݍ
		fs_gu32_addrsector = fs_g_seg.u32_addr;
		if( fat_cache_read_sector( TRUE ) )
		{
			//  ɂĂ̏XV
			fs_g_sectorcache.u32_clusterlist_start = fs_g_nav.u32_cluster_sel_dir;
			fs_g_sectorcache.u32_clusterlist_pos   = u32_cluster_pos;
			return TRUE;
		}
	}
	return FALSE;
}

//! ̊֐͓𒲂ׂ܂B
//!
//! @param	b_type	r`(FS_FILE܂FS_DIR)
//!
//! @return	TRUE	͒Zb_typeɑΉ
//! @return	FALSE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_sector							݈ʒuɑΉިڸ 
//!   fs_g_nav_fast.u16_entry_pos_sel_file	̧ٓިڸؓʒu(P)
//! @endverbatim
//!
Bool fat_entry_check (Bool b_type)
{
	PTR_CACHE u8_ptr_entry;
	U8 u8_first_byte, u8_seconde_byte;
	U8 u8_attribut;

	u8_ptr_entry = fat_get_ptr_entry();

	u8_first_byte = u8_ptr_entry[0];
	if ( FS_ENTRY_END == u8_first_byte )
	{
		fs_g_status = FS_ERR_ENTRY_EMPTY;	// ިڸ؂̍Ō
		return FALSE;
	}
	fs_g_status = FS_ERR_ENTRY_BAD;			// ɂĕs
	if ( FS_ENTRY_DEL == u8_first_byte )		{ return FALSE; }	// 폜ꂽ
	if (  '.'  == u8_first_byte )				{ return FALSE; }	// ݂ިڸ"."
	u8_seconde_byte = u8_ptr_entry[1];
	if ( ('.'  == u8_first_byte)
	 &&  ('.'  == u8_seconde_byte) )			{ return FALSE; }	// ݂ިڸ".."

	// 
	u8_attribut = u8_ptr_entry[11];
	if ( FS_ATTR_VOLUME_ID & u8_attribut )		{ return FALSE; }	// حID
	// œKA̍s̏ꍇ̐邽߁AKvł͂܂B
//	if ( FS_ATTR_LFN_ENTRY == *u8_ptr_entry)	{ return FALSE; }	// ̧ٖ

	// `
	if( FS_ATTR_DIRECTORY & u8_attribut )
	{
		return (FS_DIR == b_type);
	}else{
		return (FS_FILE == b_type);
	}
}

//! ̊֐̧يgq𒲂ׂ܂B
//!
//! @param	sz_filter	gqh߂ASCII(:"mp3,w*")
//!
//! @return	TRUE		̧ٖ͗ǂgq܂B
//! @return	FALSE		̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_sector							݈ʒuɑΉިڸ 
//!   fs_g_nav_fast.u16_entry_pos_sel_file	̧ٓިڸؓʒu(P)
//! @endverbatim
//!
Bool fat_entry_checkext (FS_STRING sz_filter)
{
	PTR_CACHE u8_ptr_entry;
	U8 u8_i, u8_filter_char, u8_entry_char;

	u8_ptr_entry = fat_get_ptr_entry();

	// gqh߂Ɣr
	for( u8_i=0 ; u8_i<3 ; u8_i++)
	{
		u8_filter_char = *sz_filter;
		if ('*' == u8_filter_char)
			break;							// SĂ̊gqǍD

		u8_entry_char = u8_ptr_entry[8+u8_i];

		// hߊgq̧يgqƔr(͂̏ꍇ𖳎)
		if( (u8_filter_char!=  u8_entry_char )
		 && (u8_filter_char!= (u8_entry_char+('a'-'A'))) )
		{
			if ( (',' == u8_filter_char)
			 ||  ( 0  == u8_filter_char) )
			{
				// h߂̏I
				if (' ' == u8_entry_char)
					break;					// ̧يgq̏Iˊgqǂ
			}
			// ͑ʖڂȊgq

			// h߂
			while( ',' != u8_filter_char )
			{
				if (0  == u8_filter_char)
				{
					return FALSE;			// ͍Ōh
				}
				sz_filter++;
				u8_filter_char = *sz_filter;
			}
			u8_i = 0xFF;					// rJԂĊJ
		}
		sz_filter++;						// h߂̎̕
	}

	return TRUE;							// ǍDȊgq
}

//! ̊֐͑I̧قɂĂ̏ǂ݂܂B
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_sector							݈ʒuɑΉިڸ 
//!   fs_g_nav_fast.u16_entry_pos_sel_file	̧ٓިڸؓʒu(P)
//! OUT:
//!   fs_g_nav_entry. u32_cluster, u8_attr, u32_size
//! @endverbatim
//!
void fat_get_entry_info (void)
{
	PTR_CACHE ptr_entry;

	ptr_entry = fat_get_ptr_entry();

	// 擾
	ptr_entry+= 11;
	fs_g_nav_entry.u8_attr = ptr_entry[0];

	// ̧ ׽ꗗ̐擪׽擾
	ptr_entry += (20-11);
	LSB2(fs_g_nav_entry.u32_cluster) = ptr_entry[0];
	LSB3(fs_g_nav_entry.u32_cluster) = ptr_entry[1];
	ptr_entry += (26-20);
	LSB0(fs_g_nav_entry.u32_cluster) = ptr_entry[0];
	LSB1(fs_g_nav_entry.u32_cluster) = ptr_entry[1];

	// ̧ٗeʎ擾
	ptr_entry += (28-26);
	LSB0(fs_g_nav_entry.u32_size) = ptr_entry[0];
	LSB1(fs_g_nav_entry.u32_size) = ptr_entry[1];
	LSB2(fs_g_nav_entry.u32_size) = ptr_entry[2];
	LSB3(fs_g_nav_entry.u32_size) = ptr_entry[3];
}

//! ̊֐̧ٓިڸ؂𒲂ׂ܂B
//!
//! @return	TRUE	̓ިڸ؂łB
//! @return	FALSE	̑
//!
Bool fat_entry_is_dir (void)
{
	fs_g_status = FS_ERR_NO_DIR;
	return (FS_ATTR_DIRECTORY & fs_g_nav_entry.u8_attr);
}

//! ̊֐͑I߲ؾĂ܂B
//!
void fat_clear_entry_info_and_ptr (void)
{
	fs_g_nav_fast.u16_entry_pos_sel_file	= FS_NO_SEL;
	fs_g_nav.u16_pos_sel_file				= FS_NO_SEL;
	if( !fs_g_nav.b_mode_nav_single )
	{
		fs_g_nav.b_mode_nav					= FS_DIR;
	}
	fs_g_nav_entry.u8_attr		= 0;
	fs_g_nav_entry.u32_cluster	= 0;
	fs_g_nav_entry.u32_size		= 0;
	Fat_file_close();
}

#if (FSFEATURE_WRITE == (FS_LEVEL_FEATURES & FSFEATURE_WRITE))
//! ̊֐͑I̧قɂĂ̏܂B
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_sector							݈ʒuɑΉިڸ 
//!   fs_g_nav_fast.u16_entry_pos_sel_file	̧ٓިڸؓʒu(P)
//! OUT:
//!   fs_g_sector							XV܂B
//! @endverbatim
//!
void fat_write_entry_file (void)
{
	PTR_CACHE ptr_entry;

	fat_cache_mark_sector_as_dirty();
	ptr_entry = fat_get_ptr_entry();

	if( !(FS_ATTR_DIRECTORY | fs_g_nav_entry.u8_attr))
	{
		if( 0 == fs_g_nav_entry.u32_size )
			fs_g_nav_entry.u32_cluster = 0;
	}

	//! 
	ptr_entry+= 11;
	ptr_entry[0] = fs_g_nav_entry.u8_attr;

	// ̧ ׽ꗗ̐擪׽
	ptr_entry += (20-11);
	ptr_entry[0] = LSB2(fs_g_nav_entry.u32_cluster);
	ptr_entry[1] = LSB3(fs_g_nav_entry.u32_cluster);
	ptr_entry += (26-20);
	ptr_entry[0] = LSB0(fs_g_nav_entry.u32_cluster);
	ptr_entry[1] = LSB1(fs_g_nav_entry.u32_cluster);

	//! ̧ق̑傫
	ptr_entry += (28-26);
	ptr_entry[0] = LSB0(fs_g_nav_entry.u32_size);
	ptr_entry[1] = LSB1(fs_g_nav_entry.u32_size);
	ptr_entry[2] = LSB2(fs_g_nav_entry.u32_size);
	ptr_entry[3] = LSB3(fs_g_nav_entry.u32_size);
}
#endif // FS_LEVEL_FEATURES

//! ̊֐͒ZO̓ԂA܂ׂ͔܂B
//!
//! @param	b_mode		:<br>
//!						FS_NAME_GET       I̧ق̒ZO𓾂邽<br>
//!						FS_NAME_CHECK     I̧ق̒ZOr邽<br>
//! @param	sz_name		FS_NAME_GETȂA(ASCII܂UNICODE)Z̧ٖi[邽߂̊ɏՕ<br>
//!						FS_NAME_CHECKȂA(ASCII܂UNICODE)Z̧ٖƔr邽߂̖O
//!						NULL܂'*'lŏI[Ȃ΂Ȃ܂B<br>
//! @param	u8_size_max	ɏՕe(ASCII܂UNICODE̒P ) ("FS_NAME_CHECK"ł͖܂B)
//!
//! @return	FALSE		ُ̏ꍇA葽̏ڍׂɂ"fs_g_status"SlB
//! @return	TRUE		O͐܂͓ǂݍOKłB
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_sector							݈ʒuɑΉިڸ 
//!   fs_g_nav_fast.u16_entry_pos_sel_file	̧ٓިڸؓʒu(P)
//! @endverbatim
//!
Bool fat_entry_shortname (FS_STRING sz_name, U8 u8_size_max, Bool b_mode)
{
	Bool b_extension_nostart = TRUE;
	U8 u8_pos_name;
	U8 u8_entry_char, u8_szname_char;
	PTR_CACHE ptr_entry;
	U8 u8_pos_entry;

	fs_g_status = FS_ERR_NAME_INCORRECT;	// ɂĖOhߖɑΉ܂B

	u8_pos_name = 0;
	u8_pos_entry = 0;
	ptr_entry = fat_get_ptr_entry();

	// ZO̊eɑ΂
	while( 1 )
	{
		if( FS_SIZE_SFNAME == u8_pos_entry )
		{
			u8_entry_char = 0;				// OI
		}
		else
		{
			u8_entry_char = ptr_entry[ u8_pos_entry ];
			if( ((FS_SIZE_SFNAME_WITHOUT_EXT == u8_pos_entry) && b_extension_nostart)	// OIA'.'Ȃ
			 || ( ' ' == u8_entry_char) )
			{
				// O܂͊gq̏I
				if( (FS_SIZE_SFNAME_WITHOUT_EXT >= u8_pos_entry)		// gqȂł̖OI
				 && (' ' != ptr_entry[ FS_SIZE_SFNAME_WITHOUT_EXT ]) )	// gq
				{
					// gqʒu
					b_extension_nostart = FALSE;
					u8_pos_entry = FS_SIZE_SFNAME_WITHOUT_EXT-1;
					u8_entry_char = '.';
				}
				else
				{
					u8_entry_char = 0;		// OI
				}
			}
		}

		if( FS_NAME_GET == b_mode )
		{
			if( !g_b_string_length )
			{
				if(u8_pos_name >= (u8_size_max-1))
					u8_entry_char = 0;		// ɏՕtȂAI

				if( ('A'<=u8_entry_char) && (u8_entry_char<='Z'))
					u8_entry_char += ('a'-'A');		// ŒZO\

				if( Is_unicode )
				{
					((FS_STR_UNICODE)sz_name)[0] = u8_entry_char;
				}else{
					sz_name[0] = u8_entry_char;
				}
			}
		}
		else
		{
			// Or
			if( Is_unicode
			&& (0 != MSB(((FS_STR_UNICODE)sz_name)[0])) )
			{
				// UNICODE͒ZOŕs
				return FALSE;
			}

			if( Is_unicode )
			{
				u8_szname_char = ((FS_STR_UNICODE)sz_name)[0];
			}else{
				u8_szname_char = sz_name[0];
			}
			if ('*' == u8_szname_char)
			{	// SĂ̎̕F؂hߖ̏I
				return TRUE;				//*** O͐ ***
			}

			if( (0 != u8_entry_char) || (('\\' != u8_szname_char) && ('/' != u8_szname_char)) )
			{
				if((u8_szname_char != u8_entry_char)
				&& (u8_szname_char != (u8_entry_char+('a'-'A'))) )	// 啶/
					return FALSE;			// ZOsv
			}
		}

		// eɑ΂
		if (0 == u8_entry_char)
		{
			if( g_b_string_length )
			{
				((FS_STR_UNICODE)sz_name)[0] = u8_pos_name+1;	// O擾
			}
			return TRUE;					// rI܂͖O擾I
		}
		if( !g_b_string_length )
		{
			sz_name += (Is_unicode? 2 : 1 );
		}
		u8_pos_name++;
		u8_pos_entry++;
	}
}

//! ̊֐͒O̓ԂA܂ׂ͔܂B
//!
//! @param	b_mode			:<br>
//!							FS_NAME_GET		I̧ق̒O𓾂邽<br>
//!							FS_NAME_CHECK	I̧ق̒Or邽<br>
//! @param	sz_name			FS_NAME_GETȂA(ASCII܂UNICODE)̧ٖi[邽߂̊ɏՕ<br>
//!							FS_NAME_CHECKȂA(ASCII܂UNICODE)̧ٖƔr閼O
//!							NULL܂'*'lɂďI[Ȃ΂Ȃ܂B<br>
//!
//! @param	b_match_case	FALSEA啶/("FS_NAME_CHECK"`ԂŎgpꍇ̂)
//! @param	u8_size_max		ɏՕe(ASCII܂UNICODE̒P) ("FS_NAME_CHECK"Ŗ܂B)
//!
//! @return	FALSE			O̍ŌłȂA܂ُ͈̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE			O͐A܂͓ǂݍݏI
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_sector							݈ʒuɑΉިڸ 
//!   fs_g_nav_fast.u16_entry_pos_sel_file	̧ٓިڸؓʒu(P)
//! @endverbatim
//!
Bool fat_entry_longname (FS_STRING sz_name, U8 u8_size_max, Bool b_mode, Bool b_match_case)
{
	U8 u8_pos_name;
	PTR_CACHE ptr_entry;
	U16 u16_unicode_entry;
	U16 u16_unicode_szname;

	ptr_entry = fat_get_ptr_entry();

	if( (FS_ENTRY_END == *ptr_entry )			// ިڸ؂̍Ō
	 || (FS_ENTRY_DEL == *ptr_entry )			// 폜ꂽ
	 || (FS_ATTR_LFN_ENTRY != ptr_entry[11]) )	// OȂ
	{
		fs_g_status = FS_ERR_ENTRY_BAD;
		return FALSE;
	}

	if( g_b_string_length )
	{
		if ( 0 == (FS_ENTRY_LFN_LAST & *ptr_entry))
		{
			// sv  ((FS_STR_UNICODE)sz_name)[0] = FS_SIZE_LFN_ENTRY;
			fs_g_status = FS_NO_LAST_LFN_ENTRY;
			return FALSE;					// ̒O
		}
	}

	ptr_entry++;							// O̧ٓ̕ψ(̾)1ŊJn

	u8_pos_name=0;
	while( 1 )
	{
		LSB(u16_unicode_entry) = ptr_entry[0];
		MSB(u16_unicode_entry) = ptr_entry[1];
		if( FS_NAME_GET == b_mode )
		{
			if( !g_b_string_length )
			{
				// ɏՕ̍Ō
				if( u8_pos_name>=(u8_size_max-1) )
				{
					// ̍Ō
					if( Is_unicode )
					{
						((FS_STR_UNICODE)sz_name)[0] = 0;
					}else{
						sz_name[0] = 0;
					}
					return TRUE;			// ɏՕt
				}
				// OǂŊi[
				if( Is_unicode )
				{
					((FS_STR_UNICODE)sz_name)[0] = u16_unicode_entry;
				}else{
					sz_name[0] = (U8)u16_unicode_entry;
				}
			}
		}
		else
		{
			if( Is_unicode )
			{
				u16_unicode_szname = ((FS_STR_UNICODE)sz_name)[0];
			}else{
				u16_unicode_szname = sz_name[0];
			}
			// O
			if( '*' == u16_unicode_szname )
			{	// SĂ̎̕F؂hߖ̍Ō
				return TRUE;				//*** O͐ ***
			}

			if( ((0 != u16_unicode_entry ) || (( '\\' != u16_unicode_szname) && ( '/' != u16_unicode_szname)) )
			 && ((u16_unicode_szname != (u16_unicode_entry+('a'-'A'))) || b_match_case)
			 && ((u16_unicode_szname != (u16_unicode_entry-('a'-'A'))) || b_match_case)
			 && (u16_unicode_szname != u16_unicode_entry) )
			{
				fs_g_status = FS_ERR_NAME_INCORRECT;	// OhߖɑΉȂB
				return FALSE;
			}
		}

		if( 0 == u16_unicode_entry)
		{
			if( g_b_string_length )
			{
				((FS_STR_UNICODE)sz_name)[0] = u8_pos_name+1;
			}
			return TRUE;					// Ō̒O
		}
		if( 4 == u8_pos_name )
			ptr_entry += 3;					// 2ڂ̕

		if( 10 == u8_pos_name )
			ptr_entry += 2;					// 3ڂ̕

		if( 12 == u8_pos_name )
		{	// O̍Ō
			ptr_entry -= (FS_SIZE_FILE_ENTRY-2);	// ̧ٓ̐擪޲Ă
			if ( 0 == (FS_ENTRY_LFN_LAST & ptr_entry[0]))
			{
				fs_g_status = FS_NO_LAST_LFN_ENTRY;
				return FALSE;				// ̒O
			}
			else
			{	// Ō̒OȂA
				// ͖O̍Ō
				if( (FS_NAME_GET == b_mode) && g_b_string_length )
				{
					((FS_STR_UNICODE)sz_name)[0] = 14;
					return TRUE;
				}
				sz_name += (Is_unicode? 2 : 1 );
				if( FS_NAME_GET == b_mode )
				{
					// UNICODE̍Ō
					if( Is_unicode )
					{
						((FS_STR_UNICODE)sz_name)[0] = 0;
					}else{
						sz_name[0] = 0;
					}
					return TRUE;
				}
				else
				{
					// h߂̍ŌȂA
					if( Is_unicode )
					{
						u16_unicode_szname = ((FS_STR_UNICODE)sz_name)[0];
					}else{
						u16_unicode_szname = sz_name[0];
					}
					return fat_check_eof_name(u16_unicode_szname);
				}
			}
		}

		if( !g_b_string_length )
		{
			sz_name += (Is_unicode? 2 : 1 );
		}
		u8_pos_name++;
		ptr_entry+=2;
	}
}

//! O̍Ō
//!
//! @param	character	邽߂̒̕l
//!
//! @return	TRUE		O̍Ō}镶(0,'\\','/')
//! @return	FALSE		̑
//!
Bool fat_check_eof_name (U16 character)
{
	return (('\0'==character)||('\\'==character)||('/'==character));
}

//! ̊֐݂͌̓ł̷ ߲Ԃ܂B
//!
//! @return	ł߲
//!
PTR_CACHE fat_get_ptr_entry (void)
{
	return &fs_g_sector[(fs_g_nav_fast.u16_entry_pos_sel_file * FS_SIZE_FILE_ENTRY) & FS_512B_MASK];
}

//! ̊֐͓  o܂B
//!
//! @param	b_load	TRUE	Ή ŷݒ<br>
//!					FALSE	 ύX܂񂪁A ڽύX܂B<br>
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_nav.u8_lun		ǂײޔԍ
//!   fs_gu32_addrsector	ǂޱڽ(P)
//! @endverbatim
//!
Bool fat_cache_read_sector (Bool b_load)
{
	// ꂽƓ
	if( (fs_g_sectorcache.u8_lun   == fs_g_nav.u8_lun )
	 && (fs_g_sectorcache.u32_addr == fs_gu32_addrsector ) )
	{
		return TRUE;
	}

	// Vŷ𖞂OɑO̷
	if( !fat_cache_flush())
		return FALSE;

	// ɂĂ̏폜
	fat_cache_reset();

	//  
	fs_g_sectorcache.u32_addr = fs_gu32_addrsector;
	if( b_load )
	{
		// ؂羸ݒ
		if( CTRL_GOOD != memory_2_ram( fs_g_nav.u8_lun  , fs_g_sectorcache.u32_addr, fs_g_sector))
		{
			fs_g_status = FS_ERR_HW;
			return FALSE;
		}
	}
	// LȾ 
	fs_g_sectorcache.u8_lun = fs_g_nav.u8_lun;
	return TRUE;
}

//! ̊֐; ؾĂ܂B
//!
void fat_cache_reset (void)
{
	fs_g_sectorcache.u8_lun                = FS_BUF_SECTOR_EMPTY;
	fs_g_sectorcache.u8_dirty              = FALSE;
	fs_g_sectorcache.u32_clusterlist_start = 0xFFFFFFFF;
}

#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
//! ̊֐; ܂B
//!
void fat_cache_clear (void)
{
	memset( fs_g_sector , 0 , FS_CACHE_SIZE );
}

//! ̊֐; ύXꂽƂ}邽߂׸ނݒ肵܂B
//!
void fat_cache_mark_sector_as_dirty (void)
{
	fs_g_sectorcache.u8_dirty = TRUE;
}
#endif // FS_LEVEL_FEATURES

//! ̊֐͕KvȂ؏̾ j܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool fat_cache_flush (void)
{
	// ύXꂽꍇAuž ܂B
	if ( TRUE == fs_g_sectorcache.u8_dirty )
	{
		fs_g_sectorcache.u8_dirty = FALSE;	// Ⴆُ킪NĂAɉ
		if( mem_wr_protect( fs_g_sectorcache.u8_lun  ))
		{
			fs_g_status = FS_LUN_WP;
			return FALSE;
		}
		if (CTRL_GOOD != ram_2_memory( fs_g_sectorcache.u8_lun , fs_g_sectorcache.u32_addr , fs_g_sector ))
		{
			fs_g_status = FS_ERR_HW;
			return FALSE;
		}
	}
	return TRUE;
}

#if (FS_NB_NAVIGATOR > 1)
//! ̊֐͏ݱ𒲂ׂ܂B
//!
//! @return	TRUE	ިł̏ݱ
//! @return	FALSE	̧قJAݱs
//!
Bool fat_check_nav_access_disk (void)
{
	U8 i;

	// eUɑ΂
	for( i=0 ; i!=(FS_NB_NAVIGATOR-1) ; i++ )
	{
		// ިt?
		if( FS_TYPE_FAT_UNM != fs_g_navext_fast[i].u8_type_fat )
		// ި?
		if( fs_g_nav.u8_lun == fs_g_navext[i].u8_lun )
		// ̧ ?
		if( fs_g_navext_entry[i].u8_open_mode!=0 )
		{
			fs_g_status = FS_ERR_FILE_OPEN;
			return FALSE;					// ̧قJAݱs
		}
	}
	return TRUE;
}

//! ̊֐̧݂͌قł̑SĂ̱𒲂ׂ܂B
//!
//! @param	mode	TRUE	ݱ<br>
//!					FALSE	ǂݍݱ<br>
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB<br>
//!					TRUȄꍇA̧قJAݱs<br>
//!					FALSȄꍇA̧قݓŊJAǂݍݱs<br>
//! @return	TRUE	̧ 
//!
Bool fat_check_nav_access_file (Bool mode)
{
	U8 i;

	// eUɑ΂
	for( i=0 ; i!=(FS_NB_NAVIGATOR-1) ; i++ )
	{
		// ިt?
		if( FS_TYPE_FAT_UNM != fs_g_navext_fast[i].u8_type_fat )
		// ި?
		if( fs_g_nav.u8_lun == fs_g_navext[i].u8_lun )
#if (FS_MULTI_PARTITION == ENABLED)
		// ߰è?
		if( fs_g_nav.u8_partition == fs_g_navext[i].u8_partition )
#endif
		// ިڸ?
		if( fs_g_nav.u32_cluster_sel_dir == fs_g_navext[i].u32_cluster_sel_dir )
		// ̧?
		if( fs_g_nav_fast.u16_entry_pos_sel_file == fs_g_navext_fast[i].u16_entry_pos_sel_file )
		{
			if( mode )
			{
				// JĂ?
				if( fs_g_navext_entry[i].u8_open_mode!=0 )
				{
					fs_g_status = FS_ERR_FILE_OPEN;
					return FALSE;			// ̧قJAݱs
				}
			}
			else
			{
				// ݓŊJĂ?
				if( fs_g_navext_entry[i].u8_open_mode & FOPEN_WRITE_ACCESS )
				{
					fs_g_status = FS_ERR_FILE_OPEN_WR;
					return FALSE;			// ̧قݓŊJAǂݍݱs
				}
			}
		}
	}
	return TRUE;
}

//! ̊֐݂̗͌Uʂ̂̂Ƌtɂ܂B
//!
//! @param	u8_idnav	tɂUID
//!
void fat_invert_nav (U8 u8_idnav)
{
	_MEM_TYPE_SLOW_ U8 Temp[Max(Max(sizeof(Fs_management),sizeof(Fs_management_entry)),sizeof(Fs_management_fast))];

	if( u8_idnav == 0 )
		return;
	u8_idnav--;

	memcpy_ram2ram(Temp,								(U8*)&fs_g_nav,						sizeof(Fs_management));
	memcpy_ram2ram((U8*)&fs_g_nav,						(U8*)&fs_g_navext[u8_idnav],		sizeof(Fs_management));
	memcpy_ram2ram((U8*)&fs_g_navext[u8_idnav],			Temp,								sizeof(Fs_management));

	memcpy_ram2ram(Temp,								(U8*)&fs_g_nav_entry,				sizeof(Fs_management_entry));
	memcpy_ram2ram((U8*)&fs_g_nav_entry,				(U8*)&fs_g_navext_entry[u8_idnav],	sizeof(Fs_management_entry));
	memcpy_ram2ram((U8*)&fs_g_navext_entry[u8_idnav],	Temp,								sizeof(Fs_management_entry));

	memcpy_ram2ram(Temp,								(U8*)&fs_g_nav_fast,				sizeof(Fs_management_fast));
	memcpy_ram2ram((U8*)&fs_g_nav_fast,					(U8*)&fs_g_navext_fast[u8_idnav],	sizeof(Fs_management_fast));
	memcpy_ram2ram((U8*)&fs_g_navext_fast[u8_idnav],	Temp,								sizeof(Fs_management_fast));
}

//! ̊֐͎Uʂ̗U֕ʂ܂B
//!
//! @param	u8_idnav	UID
//!
void fat_copy_nav (U8 u8_idnav)
{
	if( 0 != u8_idnav)
	{
		u8_idnav--;
		memcpy_ram2ram((U8*)&fs_g_navext[u8_idnav],			(U8*)&fs_g_nav,			sizeof(Fs_management) );
		memcpy_ram2ram((U8*)&fs_g_navext_entry[u8_idnav],	(U8*)&fs_g_nav_entry,	sizeof(Fs_management_entry) );
		memcpy_ram2ram((U8*)&fs_g_navext_fast[u8_idnav],	(U8*)&fs_g_nav_fast,	sizeof(Fs_management_fast) );
		fs_g_navext_entry[u8_idnav].u8_open_mode=0;		// ̧يJ׸މ
	}
}

#endif
