/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBνDFUƉp̊֐錾܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "modules/file_system/fat.h"
#include "modules/file_system/fs_com.h"
#include "modules/file_system/navigation.h"
#include "modules/file_system/file.h"
#include "modules/file_system/nav_utils.h"

#include "host_dfu_task.h"
#include "modules/usb/host_chap9/usb_host_task.h"
#include "modules/usb/host_chap9/usb_host_enum.h"
#include "lib_mcu/usb/usb_drv.h"
#include "lib_mcu/flash/flash.h"

//_____ ϸ ________________________________________________________________

#ifndef LOG_STR_CODE
#define LOG_STR_CODE(str)
#else
U8 code log_dfu_connect[]="DFU Connected";
#endif

//_____ 錾 _______________________________________________________________

U8 dfu_connected=0;

static U8 buf[MAX_DATA_PER_RECORD];
static U8 prog_buf[MAX_DATA_PER_RECORD+FLASH_PAGE_SIZE];
static U8 check_buf[MAX_DATA_PER_RECORD+FLASH_PAGE_SIZE];
static U8 dfu_status;

static U16 end_addr;
static U16 start_addr;
static U8 pgm_index=0;
static U8 pgm_nb_data=0;

U8 code firmware_name[]=FIRMWARE_NAME;

//!
//! @brief ̊֐νDFUp܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void host_dfu_task_init (void)
{
	Joy_init();
	Leds_init();
	dfu_connected=0;
}

//! @brief ̊֐νDFUpǗ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void host_dfu_task (void)
{
	if(Is_host_ready())						// (ڑF)Au͓
	{
		if(Is_new_device_connection_event())	// Vuڑė(ڑF)
		{
			// νĂATMELް۰ނɐڑꂽ
			if(Get_VID()==ATMEL_VID && Get_PID()==AT90DFU_PID)
			{
				LOG_STR_CODE(log_dfu_connect);
				dfu_connected=1;
				Led1_on();
			}
			else
			{
				dfu_connected=0;
			}
		}
		if(dfu_connected)
		{
			if(Is_joy_up()||Is_joy_left())
			{
				nav_reset();
				nav_drive_set(0);
				if(nav_partition_mount())
				{
					if(goto_code_name((U8 code *)firmware_name,FALSE,TRUE))
					{
						Led0_on();
						Dfu_erase();
						Led0_off();
						dfu_load_hex();
					}
				}
			}
		}
	}

	// uؒf
	if(Is_device_disconnection_event())
	{
		dfu_connected=0;
		Led1_off();
	}
}

//! @brief ̊֐Intel HEX̧قDFUް۰ނAT90USBxxxߏׯ ؂
//!		   ݂܂B
//!
//! @param	Ȃ
//!
//! @return	U8 (TRUE=OK, FALSE=KO)
U8 dfu_load_hex (void)
{
	U8 record_type;
	U16 addr;
	U8 nb_data;
	U8 i;
	U8 stop=0;

	dfu_status=TRUE;
	file_open(FOPEN_MODE_R);				// ̧ѳHEX̧قJB
	while (file_eof()==FALSE)
	{
		i=file_getc();
		while(i!=RECORD_MARK)
		{
			i=file_getc();
			if(file_eof())
			{
				stop=1;
				break;
			}
		}
		if(stop) break;
		// ̧قHEXںޏ\z
		nb_data=ascii_to_bin(file_getc());
		nb_data=nb_data<<4;
		nb_data+=ascii_to_bin(file_getc());
		addr=ascii_to_bin(file_getc());
		addr=addr<<4;
		addr+=ascii_to_bin(file_getc());
		addr=addr<<4;
		addr+=ascii_to_bin(file_getc());
		addr=addr<<4;
		addr+=ascii_to_bin(file_getc());
		record_type=ascii_to_bin(file_getc());
		record_type=record_type<<4;
		record_type+=ascii_to_bin(file_getc());
		for(i=0;i<nb_data;i++)
		{
			buf[i]=ascii_to_bin(file_getc());
			buf[i]=buf[i]<<4;
			buf[i]+=ascii_to_bin(file_getc());
		}
		// ںތ`
		switch(record_type)
		{
			case DATA_RECORD:
				if(addr!=end_addr+1 && pgm_index!=0)	// AڽA܂ł̊ɏՕ̍ŏ̏
				{
					dfu_flush_prog();
				}
				// ݊ɏՕɐVްǉ
				for(i=0;i<nb_data;i++)
				{
					prog_buf[pgm_index]=buf[i];
					pgm_index++;
				}
				// ݒްXV
				pgm_nb_data+=nb_data;
				// ݒ肷ŏI޲ ڽvZ
				if(pgm_nb_data>nb_data)
				{	// ɏՕް
					end_addr=end_addr+nb_data;
				}
				else // ŏ̐ݒ
				{
					end_addr=addr+nb_data-1;
					start_addr=addr;
				}
				// ް[ȂΏ݊ɏՕ
				if(pgm_index>=10*MAX_DATA_PER_RECORD)
				{
					dfu_flush_prog();
				}
				break;
			case PAGE_RECORD:
				if(pgm_index)				// ݊ɏՕłȂ?
				{
					dfu_flush_prog();		// Ȃ΂
				}
				Dfu_set_page(buf[1]);		// ߰ޕύXڰт𑗏o
			default:						// ̑SĂںތ`𖳎
				break;
		}
	}
	// ~߂OɊɏՕްc?
	if(pgm_index>0)
	{
		dfu_flush_prog();
	}
	file_close();
	Led0_off();
	return dfu_status;
}

//! @brief ̊֐AT90USBxxx DFUް۰ނDFU USB۸ݸ ڰт𑗂܂B
//!
//! @param	start	: Jnڽ
//! @param	end		: Iڽ
//! @param	*buf	: ްɏՕւ߲
//!
//! @return	Ȃ
void dfu_prog (U16 start,U16 end,U8 *buf)
{
	U8 i;
	U16 j;
	U8 padding;

	data_stage[0]=0x01;
	data_stage[1]=0;
	data_stage[2]=MSB(start);
	data_stage[3]=LSB(start);
	data_stage[4]=MSB(end);
	data_stage[5]=LSB(end);
	for(i=6;i<32;i++)
	{
		data_stage[i]=0;
	}
	padding=start%32;
	j=padding;
	while(j)
	{
		data_stage[i]=0x00;
		i++; j--;
	}
	j=end-start+1;
	while(j)
	{
		data_stage[i]=*buf;
		buf++;
		j--;i++;
	}
	Dfu_download(32+end-start+1+padding);
}

void dfu_read (U16 start,U16 end,U8 *buf)
{
	U16 j;
	U16 i;

	data_stage[0]=0x03;
	data_stage[1]=0;
	data_stage[2]=MSB(start);
	data_stage[3]=LSB(start);
	data_stage[4]=MSB(end);
	data_stage[5]=LSB(end);
	Dfu_download(6);
	i=end-start+1;
	Dfu_upload(i);
	for(j=0;j<i;j++)
	{
		*buf=data_stage[j];
		buf++;
	}
}

void dfu_flush_prog (void)
{
	U8 i;
	// SĂׯ  ߰ޓɊɏ?
	if( MSB(start_addr)== MSB(end_addr))
	{
		dfu_prog(start_addr,end_addr,prog_buf);
	}
	else // A2ŏ
	{
		i=(end_addr%FLASH_PAGE_SIZE);
		dfu_prog(start_addr,end_addr-i-1,prog_buf);
		dfu_prog(end_addr-i,end_addr,&prog_buf[pgm_nb_data-i-1]);
	}
	// ƍs
	dfu_read(start_addr,end_addr,check_buf);
	for(i=0;i<pgm_nb_data;i++)
	{
		if(prog_buf[i]!=check_buf[i])
		{
			Leds_on();
			dfu_status=FALSE;
		}
	}
	Led0_toggle();
	pgm_index=0;
	pgm_nb_data=0;
}

U8 ascii_to_bin (U8 b)
{
	b |= 'a'-'A';							// ϊ: '0'=>'0', 'A'=>'a', 'a'=>'a'
	return ( (b <= '9') ? (b-'0') : (b+10-'a') );
}
